<script>
import { error_message } from "../../Helper/helper";
import config from "../../config";
import { authService } from "../../services"
import { required, email, sameAs,maxLength } from "vuelidate/lib/validators";

/**
 * signup component
 */

export default {  
  data() {
    return {
      config: config,
      error: "",
      agree_te_co_error:false,
      signup: {
        restaurant_name:'',
        email: '',
        client_name:'',
        password: '',
        confirm_password:'',
        agree_te_co:false,
        contact_number:'',
        recaptcha:''
      },
      sitekey:''
    };
  },
  validations: {
    signup: {
        restaurant_name:{
          required,
        },
        email: {
            required,
            email,
        },
        client_name:{
            required,
        },
        password: {
            required,
        },
        confirm_password: {
            required,
            sameAsPassword: sameAs('password')
        },
        agree_te_co: {
            required,
        },
        contact_number: {
          required,
          maxLength:maxLength(12)
        },
        recaptcha: {
          required,          
        }
    },
  },

  mounted() {
    this.sitekey = process.env.MIX_GOOGLE_RECAPTCHA_SITE_KEY;
    window.grecaptcha.render('g-recaptcha', {
      sitekey: this.sitekey,
      size: 'visible',
      // the callback executed when the user solve the recaptcha
      callback: (response) => {        
        this.signup.recaptcha = response;
        this.$v.signup.$touch();
        // emit an event called verify with the response as payload        
        this.$emit('verify', response);
        // reset the recaptcha widget so you can execute it again
        this.reset();
      }
    })
  },
  methods: {
    signupIt() {
      this.signup.recaptcha = window.grecaptcha.getResponse();
      this.$v.signup.$touch();
      if (this.$v.signup.$invalid) {
        if(!this.signup.agree_te_co){
          this.agree_te_co_error = true;
        }
        return;
      } else {
        if(this.signup.agree_te_co){
          localStorage.removeItem('new_signup_email');
          this.agree_te_co_error = false;
            this.signup.login_type = "client";
            authService.signupClient(this.signup).then((responce) => {
                if (responce.data.code == 200) {
                  localStorage.setItem('new_signup_email',this.signup.email);
                  localStorage.setItem('new_client_name',this.signup.client_name);
                  this.$router.push({ name:'confirm-email', params:{client_id: btoa(responce.data.result.client_id)} })
                }else{
                  error_message(responce.data.message)
                }
            })
            // this.$auth.login(this.signup, (type) => {
            //   this.$router.push({ name: type });
            // });
        }else{
            this.agree_te_co_error = true;
        }
      }
    },

    agree_te_co_fn(){
        if(!this.signup.agree_te_co){
            this.agree_te_co_error = true;
        }else{
            this.agree_te_co_error = false;
        }
    },

    isNumber: function(evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }
    }
  },
};
</script>

<template>
  <div>
    <div class="account-pages my-5 pt-5">
      <div class="container">
         <div class="row justify-content-center">
          <div class="col-md-8 col-lg-6 col-xl-6 login-main">
            <div class="card overflow-hidden">
              <div class="bg-soft-primary">
                <div class="row">
                  <div class="col-12 text-center">
                    <div class="text-primary p-4">
                      <h3 class="text-primary">Signup For Ressto</h3>                      
                    </div>
                  </div>
                </div>
              </div>
              <div class="card-body pt-0">
                <b-form class="p-2 mt-4" @submit.prevent="signupIt">
                  <div class="alert alert-danger" v-show="this.error">{{ this.error }}</div>
                  <slot />
                  <div class="row">
                    <div class="col-md-6">
                        <!-- restaurant name -->
                        <b-form-group
                          id="input-group-3"
                          label-for="input-3"
                        >
                          <b-form-input
                            id="input-3"
                            name="restaurant_name"
                            ref="restaurant_name"
                            v-model="$v.signup.restaurant_name.$model"
                            type="text"
                            :placeholder="this.trans.get('__JSON__.Restaurant Name')"
                            :class="{ 'is-invalid':  $v.signup.restaurant_name.$error }"
                          ></b-form-input>
                          <div v-if="$v.signup.restaurant_name.$error" class="invalid-feedback">
                            <span
                              v-if="!$v.signup.restaurant_name.required"
                            >{{ trans.get('__JSON__.Please enter Restaurant Name') }}</span>
                          </div>
                        </b-form-group>
                    </div>
                    <div class="col-md-6">
                        <!-- client_name -->
                        <b-form-group
                        id="input-group-4"
                        label-for="input-4"
                        >
                        <b-form-input
                            id="input-4"
                            name="name"
                            ref="name"
                            v-model="$v.signup.client_name.$model"
                            type="text"
                            :placeholder="this.trans.get('__JSON__.Your Name')"
                            :class="{ 'is-invalid':  $v.signup.client_name.$error }"
                        ></b-form-input>
                        <div v-if="$v.signup.client_name.$error" class="invalid-feedback">
                            <span
                            v-if="!$v.signup.client_name.required"
                            >{{ trans.get('__JSON__.Please enter Your Name') }}</span>
                        </div>
                        </b-form-group>
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-md-6">
                        <!-- email -->
                        <b-form-group
                          id="input-group-1"
                          label-for="input-1"
                        >
                          <b-form-input
                            id="input-1"
                            name="email"
                            ref="email"
                            v-model="$v.signup.email.$model"
                            type="text"
                            :placeholder="this.trans.get('__JSON__.Email')"
                            :class="{ 'is-invalid':  $v.signup.email.$error }"
                          ></b-form-input>
                          <div v-if="$v.signup.email.$error" class="invalid-feedback">
                            <span
                              v-if="!$v.signup.email.required"
                            >{{ trans.get('__JSON__.Please enter email') }}</span>
                            <span
                              v-if="!$v.signup.email.email"
                            >{{ trans.get('__JSON__.This value should be a valid email') }} Ex:-xxx@xxx.xxx</span>
                          </div>
                        </b-form-group>
                    </div>
                    <div class="col-md-6">
                        <!-- contact_number -->
                        <b-form-group
                          id="input-group-7"
                          label-for="input-7"
                        >
                          <b-form-input
                            id="input-7"
                            name="contact_number"
                            ref="contact_number"
                            v-model="$v.signup.contact_number.$model"
                            type="number"
                            @keypress="isNumber($event)"
                            :placeholder="this.trans.get('__JSON__.Contact number')"
                            :class="{ 'is-invalid':  $v.signup.contact_number.$error }"
                          ></b-form-input>
                          <div v-if="$v.signup.contact_number.$error" class="invalid-feedback">
                            <span
                              v-if="!$v.signup.contact_number.required"
                            >{{ trans.get('__JSON__.Please enter contact number') }}</span>
                            <span
                              v-if="!$v.signup.contact_number.maxLength"
                            >{{ trans.get('__JSON__.Please enter a max 12 numbers') }} </span>
                          </div>
                        </b-form-group>

                    </div>
                  </div>
                  <div class="row">
                    <div class="col-md-6">
                        <!-- password -->
                        <b-form-group
                          id="input-group-2"
                          label-for="input-2"
                        >
                          <b-form-input
                            id="input-2"
                            v-model="$v.signup.password.$model"
                            name="password"
                            type="password"
                            :placeholder="this.trans.get('__JSON__.Password')"
                            :class="{ 'is-invalid':  $v.signup.password.$error  }"
                          ></b-form-input>
                          <div v-if="$v.signup.password.$error" class="invalid-feedback">
                            <span
                              v-if="!$v.signup.password.required"
                            >{{ trans.get('__JSON__.Please enter password')}}</span>
                          </div>
                        </b-form-group>
                    </div>
                    <div class="col-md-6">
                        <!-- confirm password -->
                        <b-form-group
                          id="input-group-5"
                          label-for="input-5"
                        >
                          <b-form-input
                            id="input-5"
                            v-model="$v.signup.confirm_password.$model"
                            name="confirm_password"
                            type="password"
                            :placeholder="this.trans.get('__JSON__.Confirm Password')"
                            :class="{ 'is-invalid':  $v.signup.confirm_password.$error  }"
                          ></b-form-input>
                          <div v-if="$v.signup.confirm_password.$error" class="invalid-feedback">
                              <span v-if="!$v.signup.confirm_password.required">
                                  {{ trans.get('__JSON__.Please enter confirm password')}}
                              </span>
                              <span v-if="signup.confirm_password && !$v.signup.confirm_password.sameAsPassword">
                                {{ trans.get('__JSON__.Password and Confirm Password Should Match') }}
                              </span>
                          </div>
                        </b-form-group>
                    </div>
                  </div>
                  <div class="row">
                    <div class="col-md-6">
                      <div class="g-recaptcha" :class="{ 'is-invalid':  $v.signup.recaptcha.$error  }" ref="recaptcha" id="g-recaptcha" :data-sitekey="sitekey"></div>
                      <div v-if="$v.signup.recaptcha.$error" class="invalid-feedback">
                        <span>{{ trans.get('__JSON__.Recaptcha requires verification.')}}</span>
                      </div>
                    </div>                    
                  </div>                 
                  <!-- checkbox -->
                    <div class="form-check  mb-3">
                        <input
                        class="form-check-input"
                        type="checkbox"
                        id="formCheckRight1"
                        v-model="$v.signup.agree_te_co.$model"
                        :class="{ 'is-invalid':  agree_te_co_error  }"
                        @change="agree_te_co_fn"
                        />
                        <label class="mt-1" for="formCheckRight1">
                            {{ trans.get('__JSON__.By Doing Signup I Agree with Terms & Condition of Ressto') }}
                        </label>
                        <div v-if="agree_te_co_error" class="invalid-feedback">
                            <span
                                v-if="agree_te_co_error"
                            >
                                {{ trans.get('__JSON__.Please select the checkbox')}}
                            </span>
                        </div>
                    </div>
                    
                    <div>
                    <button
                    class="btn btn-primary btn-block"
                    @keyup.enter="signupIt"
                    >{{ trans.get('__JSON__.Signup') }}</button>
                  </div>
                  <!-- <div class="col-sm-12">
                    <div class="row">
                      <div class="col-sm-12">
                        <div class="mt-3 text-center">
                          <router-link to="forgot-password" class="text-muted">
                            <i class="mdi mdi-lock mr-1"></i>
                            {{ trans.get('__JSON__.Forgot your password') }}?
                          </router-link>
                        </div>
                      </div>
                    </div>
                  </div> -->
                </b-form>
              </div>
              <!-- end card-body -->
            </div>
            <!-- end card -->
          </div>
          <!-- end col -->
        </div>
         <!-- end row -->
      </div>
    </div>
  </div>
</template>
